/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

#include <stdio.h>
#include "main.h"
#include <qapplication.h>
#include <qmainwindow.h>
#include <qpushbutton.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include "mainwin.h"
#include <fcntl.h>
#include <unistd.h>
#include <qwidget.h>
#include "logo.h"
#include <stdlib.h>

struct cnf mconf;

void file_close(int f)
{
  close(f);
}

int main(int argc, char **argv)
{
QApplication a(argc,argv);
logo *login_window=new logo();
char logopath[256];


memset(&mconf,0,sizeof(mconf));
memset(&mconf.col,255,sizeof(colors));
strcpy(mconf.home,(const char *)getenv("HOME"));
strcpy(mconf.soundconf,(const char *)getenv("SOUNDMAN"));
if (mconf.soundconf==NULL) strcpy(mconf.soundconf,"/usr/local/SoundMan");
strcat(mconf.home,"/.SoundMan/");
strcpy(logopath,mconf.soundconf);
strcat(logopath,"/logo.bmp");
login_window->load_bground(logopath);

if (login_window->exec())
{
  QMainWindow mw;
  mainwin as(&mw);
  login_window->close();
  mconf.wave.zoomx=1;
  mconf.spect.zoomx=1;
  mconf.noise=(float *)calloc(8192,sizeof(float));
  memset(mconf.noise,0,8192*sizeof(float));
  QPopupMenu *fileMenu=new QPopupMenu;
  QPopupMenu *helpMenu=new QPopupMenu;
  QPopupMenu *optionMenu=new QPopupMenu;
  QPopupMenu *waveMenu=new QPopupMenu;
  QPopupMenu *fftMenu=new QPopupMenu;
  QPopupMenu *effectMenu=new QPopupMenu;
//  fileMenu->insertSeparator(3);
  fileMenu->insertItem("Quit",qApp,SLOT(quit()));
  optionMenu->insertItem("Device",&as,SLOT(config_dev()));
  optionMenu->insertItem("Colors",&as,SLOT(colsetup()));
  waveMenu->insertItem("Record...",&as,SLOT(record()));
  waveMenu->insertItem("Play...",&as,SLOT(play()));
  waveMenu->insertItem("Record noise...",&as,SLOT(recnoise()));
  fftMenu->insertItem("Power Spectrum",&as,SLOT(fft()));
  fftMenu->insertItem("Spektogram",&as,SLOT(spgr()));
  fftMenu->insertItem("Realtime Spektrum",&as,SLOT(realtime()));
  effectMenu->insertItem("Frequency filter",&as,SLOT(f_filter()));
  effectMenu->insertItem("Noise filtering",&as,SLOT(noise_filtering()));
//  helpMenu->insertItem("Contents");
  helpMenu->insertItem("About");
  mw.menuBar();
  (mw.menuBar())->insertItem("File",fileMenu);
  (mw.menuBar())->insertItem("Option",optionMenu);
  (mw.menuBar())->insertItem("Wave",waveMenu);
  (mw.menuBar())->insertItem("FFT",fftMenu);
  (mw.menuBar())->insertItem("Effects",effectMenu);
  (mw.menuBar())->insertSeparator(-1);
  (mw.menuBar())->insertItem("Help",helpMenu);
  mw.setMinimumWidth(560);
  mw.setMinimumHeight(440);
  as.setMinimumWidth(560);
  as.setMinimumHeight(440);
  mw.show();
  as.show();
  mw.setCentralWidget(&as);
  a.setMainWidget(&as);
  mw.setCaption("SoundMan - MainWindow");
  as.show();
  a.exec();
}
}
